const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const employeeGradeService = require('./employeeGrade.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new employeeGrade
 * @param {Object} req.body - The employeeGrade data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created employeeGrade
 */
function create(req, res, next) {
    employeeGradeService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all employeeGrades
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employeeGrades
 */
function getAll(req, res, next) {
    employeeGradeService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of employeeGrade objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employeeGrade objects
 */
function option(req, res, next) {
    employeeGradeService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of employeeGrades matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of employeeGrades
 */
function count(req, res, next) {
    employeeGradeService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing employeeGrade
 * @param {number} req.params.id - The employeeGrade ID to be updated
 * @param {Object} req.body - The employeeGrade data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated employeeGrade
 */
function update(req, res, next) {
    employeeGradeService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a employeeGrade
 * @param {number} req.params.id - The employeeGrade ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    employeeGradeService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
